<?php
  include_once("gxml.php");
  include_once("background.php");
  include_once("htmlfuncs.php");
  include_once("pagemenu.php");
  include_once("checkout.php");  
  
  function ItemLink($Item)
  {
    $Result  = DetailFile()."?ASIN=".rawurlencode($Item->ASIN[0]->Data);
    
    return $Result;
  }
  
  function GetItemNumber($Item, $ItemIndex, $Width)
  {
    $Result  = "<TABLE WIDTH=\"$Width\">";
    $Result .= TR("<TD HEIGHT=\"15\">$ItemIndex.</TD>");
    $Result .= TRTD("&nbsp;");
    $Result .= "</TABLE>";
    return $Result;
  }

  function GetItemImageRef($Item, $Caption)
  {
    $str = "\$Temp = \$Item->$Caption"."[0]"."->Data;";
    eval("\$Temp = \$Item->$Caption"."[0]"."->Data;");
    return $Temp;
  }

  function GetItemImage($Item, $Caption)
  {
    $Result  = "<TABLE>";
    $Result .= TRTD(href(Img(GetItemImageRef($Item, $Caption)), ItemLink($Item)));
    $Result .= "</TABLE>";
    return $Result;
  }
  
  function GetArtists($Artists)
  {
    $Result = "";
    $i = 0;
    while (isset($Artists->ARTIST[$i]->Data))
    {
      if ($i != 0)
      {
        $Result .= ", ";
      }
      $Result .= $Artists->ARTIST[$i]->Data;
      $i++;
    }    
    return $Result;
  }
  
  function GetAuthors($Authors)
  {
    $Result = "";
    $i = 0;
    while (isset($Authors->AUTHOR[$i]->Data))
    {
      if ($i != 0)
      {
        $Result .= ", ";
      }
      $Result .= $Authors->AUTHOR[$i]->Data;
      $y = strlen( $Authors->AUTHOR[$i]->Data);
      $i++;
    }
    $z = utf8_encode($Result);
    $q = str_replace("\xe9", "e", $Result);
    $x = strpos($Result, "\\xe9");
    return $Result;
  }  
  
  function GetItemDetail($Item)
  {
    $Result  = "<TABLE>";
    $Result .= TRTD(href($Item->PRODUCTNAME[0]->Data, ItemLink($Item)));
    $Result .= TRTD(GetArtists($Item->ARTISTS[0]).GetAuthors($Item->AUTHORS[0]));
    $Result .= "</TABLE>";
    return $Result;
  }
  
  function GetItemPrice($Item, $Width)
  {
    $Result  = TRTDC("<B>List Price:</B> ".$Item->LISTPRICE[0]->Data);
    $Result .= TRTDC("<B>Our Price: ".Font("Arial", 3, $Item->OURPRICE[0]->Data, "#008000")."</B>");
    return TableW($Result,$Width);

  }
 
  function GetImageSizeCaption($ImageSize)
  {
    $Result = "IMAGEURLSMALL";
    if ($ImageSize==2)
    {
      $Result = "IMAGEURLMEDIUM";
    }
    else
    {
      if ($ImageSize==3)
      {
        $Result = "IMAGEURLLARGE";
      }
    }
    return $Result;
  }
  
  //Returns the list price of an item if it exists, nothing if it does not.
  function ListPrice($Item)
  {
    if (isset($Item->LISTPRICE[0]->Data))
    {
      $Result = "Suggested Price:".$Item->LISTPRICE[0]->Data;
    }
    else
    {
      $Result = nbsp("");
    }
    return TRTDC(Font("ARIAL", 1, $Result));
  }

  function OurPrice($Item)
  {
    if (isset($Item->OURPRICE[0]->Data))
    {
      $Result = Font("ARIAL", 1,"Our Price:".$Item->OURPRICE[0]->Data);
    }
    else
    {
      $Result = "Not available";
    }   
    return TRTDC(Font("ARIAL", 1, $Result));
  }
  
  //Returns and HTML table-column consisting of $Item's details of width $Width.
  function GetItemTD($Item, $Width, $ImageSize, $ItemIndex)
  {
    $ImageSizeCaption = GetImageSizeCaption($ImageSize);
    
    $Result = "<TD WIDTH=$Width>\n";
    
    $Result .= "<TABLE>";
    if (isset($Item->PRODUCTNAME[0]->Data))//Show nothing if there is no product.
    {
      /*JG Commented out.  Items are now shown vertically...
      $Result .= TRTDC(href($Item->PRODUCTNAME[0]->Data, ItemLink($Item)));
      $Result .= TRTDC(href(Img(GetItemImage($Item, $ImageSizeCaption)), ItemLink($Item)));
      $Result .= ListPrice($Item);
      $Result .= OurPrice($Item);
      */
      $Result .= "<TR>\n";
      $Result .= TD(GetItemNumber($Item, $ItemIndex, 50));
      $Result .= TD(GetItemImage($Item, $ImageSizeCaption, 100));
      $Result .= TDW(GetItemDetail($Item),"100%");
      $Result .= TD(GetItemPrice($Item, 200));      
      $Result .= "</TR>\n";
    }

    $Result .= "</TABLE>\n";
    $Result .= "</TD>\n";
    
    return $Result;
  }
  
  //Retuns an HTML table-row consisting of $ItemsPerRow number of items from $Obj starting
  // at item number $Index * $ItemsPerRow -1.
  function GetObjTR($Obj, $ItemsPerRow, $Index, $ColumnWidth, $ImageSize, $Page, $ItemIndex)
  {
    $Result = "<TR>";
    
    //Add the columns to the result.
    for($i = 0; $i < $ItemsPerRow; $i++)
    {
      $Item = GetItem($Obj, $Index * $ItemsPerRow + $i);
      $Result .= GetItemTD($Item, $ColumnWidth, $ImageSize, ($Page * 10 - 9 + $ItemIndex));
    }
    
    $Result .= "</TR>";
    return $Result;
  }
  
  //Returns the item under the XML DETAILS[$Index].  Inspect $Obj for more details.
  function GetItem($Obj, $Index)
  {
    if (isset($Obj->PRODUCTINFO[0]->DETAILS[$Index]))
    {
      return $Obj->PRODUCTINFO[0]->DETAILS[$Index];
    }
    else
    {
      return 0;
    }
  }
  
  //Returns an HTML table of the items.
  function GetItemList($Obj, $ItemsPerRow, $ImageSize, $Page)
  {
    $TableWidth  = "100%";
    $Items       = 10;
    $ColumnWidth = $TableWidth;// /$ItemsPerRow;
    $Result = "";
    
    $Result .= "<TABLE WIDTH=$TableWidth>\n";
      
    //Create Rows
    for($i = 0; $i < $Items / $ItemsPerRow; $i++)
    {
      //$Item = GetItem($Obj, $i);
      $Result .= GetObjTR($Obj, $ItemsPerRow, $i, $ColumnWidth, $ImageSize, $Page, $i);
    }
    
    $Result .= "</TABLE>\n";
    return $Result;
  }
  
  //Creates a list of clickable items to purchase.  Clicking on each item
  // brings up a detail screen.
  //$ImageSize 1: SMALL, 2: MEDIUM, 3: LARGE
  function body($Associate, $Category, $Keywords, $Page, $Sort, $CartID, $HMAC, $ItemsPerRow, $ImageSize)
  {
    $Result      = "";
    $Filename    = "http://xml.amazon.com/onca/xml2?t=" . $Associate . "&dev-t=".DevKey()."&mode=".$Category."&type=lite&page=" . $Page . "&f=xml&KeywordSearch=" . rawurlencode($Keywords) . "&sort=$Sort";
    $Obj         = GXMLTree($Filename);
    $TotalPages  = $Obj->PRODUCTINFO[0]->TOTALPAGES[0]->Data;
    $PageLink    = RootFile()."?Category=$Category&Keywords=".rawurlencode($Keywords);
    $Result     .= PageMenu($Page, $TotalPages, $PageLink, 500);
    $Result     .= checkout();    
    $Result     .= GetItemList($Obj, $ItemsPerRow, $ImageSize, $Page);
    $Result     .= PageMenu($Page, $TotalPages, $PageLink, 500);    
    return $Result;
  }
?>